﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Windows.Forms;
using System.Threading;
using System.Globalization;

namespace RSP_Checksum
{
    public class checksum
    {

        private int interrocode = 0;

        public delegate void UpdateForm();
        //updateform

        private UpdateForm funcaointerna;

        private UpdateForm funcaofinish;

        private System.Windows.Forms.Timer timer;

        private System.Windows.Forms.Timer timer2;

        [DllImport("kernel32.dll")]
        private static extern int GetProcAddress(int hModule, string lpProcName);

        [DllImport("kernel32.dll")]
        private static extern int FreeLibrary(int hLibModule);

        [DllImport("kernel32.dll")]
        private static extern int LoadLibraryA(string lpLibFileName);

        [DllImport("user32.dll", EntryPoint = "CallWindowProc")]
        private static extern int CallWindowProcint(int lpPrevWndFunc, string Hwnd, int msg, int wParam, int lParam);

        [DllImport("user32.dll", EntryPoint = "CallWindowProc")]
        private static extern int CallWindowProcString(int lpPrevWndFunc, string Hwnd, string msg, string wParam, string lParam);

        [DllImport("user32.dll", EntryPoint = "CallWindowProc")]
        private static extern int CallWindowProcStringBuilder(int lpPrevWndFunc, string Hwnd, StringBuilder msg, StringBuilder wParam, StringBuilder lParam);

        private static int dllvalue = 0;
        private static int nomore = 0;
        private static int dllfunction = 0;


        public checksum()
        {
            init();

            timer = new System.Windows.Forms.Timer();
            timer.Enabled = false;
            timer.Interval = 100;
            timer.Tick += new System.EventHandler(TimerTick);

            timer2 = new System.Windows.Forms.Timer();
            timer2.Enabled = false;
            timer2.Interval = 1000;
            timer2.Tick += new System.EventHandler(TimerTick2);

        }

        void TimerTick(object sender, System.EventArgs e)
        {
            //timer
            //Trace.WriteLine ("Raising timer 1 ");

            if (funcaointerna != null)
            {
                // Trace.WriteLine ("Vai chamar funcao porque nao é null ");
                funcaointerna();

            }
            else
            {
                //Trace.WriteLine ("Nao vai chamar funcao porque é null ");
            }


            /*6/1/2004 19:17

            Teria que facilitar ao maximo a utilizacao do programa

            Seria bom dar uma lida naquilo , nao é mesmo
            */
            timer.Interval = 1000;

        }

        void TimerTick2(object sender, System.EventArgs e)
        {
            //timer
            //Trace.WriteLine ("Raising timer 2 ");

            timer2.Interval = 100;


            if (status() == 0)
            {
                if (funcaofinish != null)
                {
                    //Trace.WriteLine ("Vai chamar funcao porque nao é null ");
                    funcaofinish();

                }
                else
                {
                    // Trace.WriteLine ("Nao vai chamar funcao porque é null ");
                }
                timer2.Enabled = false;
                timer.Enabled = false;

            }

            /*6/1/2004 19:17

            Teria que facilitar ao maximo a utilizacao do programa

            Seria bom dar uma lida naquilo , nao é mesmo
            */



        }
        	   ~checksum ()
	   {


	      Trace.WriteLine ("Executando Destructor no MP3 player ");
/*
Cada coisa a seu tempo

Nada acontece fora da hora certa
Cada coisa amadurece na hora correta e com sua certa razao de ser
Pod ter paciencia e seguir em frente que ta tudo cero

*/



	   }

               private int init()
               {

                   //init

                   if (nomore != 0)
                   {

                       Trace.WriteLine("Unable to locate dll \n ");
                       return 3;


                   }


                   if (dllvalue != 0)
                   {

                       // Trace.WriteLine ("Already loaded \n ");
                       return 0;


                   }
                   else
                   {
                       Trace.WriteLine("Loading dll \n ");
                   }


                   dllvalue = LoadLibraryA("rspmp3player.dll");

                   Trace.WriteLine("Ret de carregamento de DLL {1} \n ", dllvalue.ToString());

                   if (dllvalue == 0)
                   {

                       MessageBox.Show ("Unable to load the required DLL rspmp3player.dll ");
                       nomore = 1;

                       return 2;

                   }
                   // estamos em return 4

                   dllfunction = GetProcAddress(dllvalue, "interface1");

                   if (dllfunction == 0)
                   {

                       MessageBox.Show ("Unable to load the required function in the DLL rspmp3player.dll ");
                       nomore = 1;

                       return 4;

                   }


                   Trace.WriteLine("Ok locating the exported function interface1 \n");




                   return 0;

               }



               private int deinit()
               {
                   //deinit
                   int ret;

                   if (dllvalue == 0)
                   {

                       Trace.WriteLine("Already unloaded \n ");
                       return 1;

                   }
                   else
                   {
                       Trace.WriteLine("Unloading DLL \n ");
                   }

                   ret = FreeLibrary(dllvalue);

                   Trace.WriteLine("Retorno de descarregamento {0} \n ", ret.ToString());
                   // é diferente mesmo ele imprime o treco trocado

                   if (ret == 0)
                   {

                       Trace.WriteLine("Unable to unload the DLL \n ");
                       return 2;
                   }
                   else
                   {
                       Trace.WriteLine("Ok unloading DLL \n ");
                       dllvalue = 0;

                   }

                   return 0;

               }

               public int status()
               {
                   if (init() != 0)
                   {
                       Trace.WriteLine("Open failed \n");
                       return 0;

                   }
                   return CallWindowProcString(dllfunction, "bstatus", " ", " ", " ");


               }

    }
}
